/*
 * C
 *
 * Copyright 2013 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
#include <RTL.h>
#include <stdio.h>
#include "microej.h"

#define SENSORSTASK_STACK_SIZE 256

static U64 sensorsTaskStack[(SENSORSTASK_STACK_SIZE)/8];

int32_t NUMBER_OF_SENSORS = 5;
int32_t* SENSORS_VALUES;

__task void sensorsTask(void )
{
	printf("[EmbJPF] - update sensors values\n");
	for (int i = 0; i < NUMBER_OF_SENSORS; i++) 
	{
		SENSORS_VALUES[i] = i * 10;
	}
	
	// Wait 750 ms so that application can read new buffer values
	// and modify them
	os_dly_wait(75);
	
	printf("[EmbJPF] - Read sensors values : \n");
	for (int i = 0; i < NUMBER_OF_SENSORS; i++) 
	{
		printf("[EmbJPF] - Sensor_%d = %d \n", i, SENSORS_VALUES[i]);
	}
	// Need to delete itself in order to schedule other tasks
	os_tsk_delete_self();
}

int32_t Java_com_is2t_appnote_NativesInterface_getNumberOfSensors()
{
	return NUMBER_OF_SENSORS;
}

void Java_com_is2t_appnote_NativesInterface_init(int32_t* buffer)
{
	// Store buffer address
	SENSORS_VALUES = buffer;
	// Create and launch a task
	os_tsk_create_user(sensorsTask, 10, &sensorsTaskStack, sizeof(sensorsTaskStack));
}
